using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;


namespace GGC_Group
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridGroupingControl1.Location = new System.Drawing.Point(0, 0);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(592, 334);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "3.301.0.0";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(592, 334);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			
			DataTable dt = new DataTable("MyTable");

			int nCols = 3;
			int nRows = 20;
			Random r = new Random(15345345);

			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i), typeof(int)));
			dt.Columns.Add(new DataColumn(string.Format("CheckBox"), typeof(bool)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
					dr[j] = r.Next(10);
				dr["Col1"] = i%5;
				dt.Rows.Add(dr);
			}

			this.gridGroupingControl1.DataSource = dt;
			this.gridGroupingControl1.ShowGroupDropArea = true;
			this.gridGroupingControl1.ChildGroupOptions.IsExpandedInitialValue = true;  
			this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add("Col1");  
			this.gridGroupingControl1.TableDescriptor.Appearance.GroupCaptionRowHeaderCell.CellType = "CheckBox";    	
			this.gridGroupingControl1.TableDescriptor.Appearance.GroupCaptionRowHeaderCell.CheckBoxOptions = new GridCheckBoxCellInfo("1","0","-1",true); 
			
			this.gridGroupingControl1.TableControlCheckBoxClick +=new GridTableControlCellClickEventHandler(gridGroupingControl1_TableControlCheckBoxClick);
			this.gridGroupingControl1.QueryCellStyleInfo +=new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo); 


		}
		Hashtable GroupCheckValue = new Hashtable();

		private void gridGroupingControl1_TableControlCheckBoxClick(object sender, GridTableControlCellClickEventArgs e)
		{
			int RowIndex = e.Inner.RowIndex;
			int ColIndex = e.Inner.ColIndex;
			if( RowIndex > -1 && ColIndex > -1)
			{
				GridTableCellStyleInfo Style = e.TableControl.Model[RowIndex,ColIndex] as GridTableCellStyleInfo;   
				if( Style != null && Style.TableCellIdentity.TableCellType == GridTableCellType.GroupCaptionRowHeaderCell )
				{
					Element el = Style.TableCellIdentity.DisplayElement;
					if( el!= null && el.ParentGroup != null 
						&& el.ParentGroup.Category.ToString()  != string.Empty )
					{
						if( GroupCheckValue.Contains( el.ParentGroup.Name  + ":::" + el.ParentGroup.Category ))
						{
							object cellValue = GroupCheckValue[el.ParentGroup.Name + ":::" + el.ParentGroup.Category];
							if( cellValue != null && cellValue.ToString() != string.Empty)  
							{
								GroupCheckValue[el.ParentGroup.Name  + ":::" + el.ParentGroup.Category] = cellValue.ToString() == "1" ? "0": "1";
								SetCheckStatus(el.ParentGroup,"CheckBox", cellValue.ToString() == "1" ? false: true);
							}
						}
						else
						{
							GroupCheckValue.Add( el.ParentGroup.Name  + ":::" + el.ParentGroup.Category,"1" );
							SetCheckStatus(el.ParentGroup,"CheckBox", true);
						}
					}
				}
			}
		}

		private void SetCheckStatus( Group g, string ColumnName, bool bvalue)
		{
			foreach( Group group in g.Groups)
				SetCheckStatus( group, ColumnName,bvalue);
			foreach( Record rec in g.Records)
				rec.SetValue( ColumnName,bvalue);

		}

		private void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			if(e.TableCellIdentity.TableCellType == GridTableCellType.GroupCaptionRowHeaderCell )
			{
				Element el = e.TableCellIdentity.DisplayElement;
				if( el!= null && el.ParentGroup != null 
					&& el.ParentGroup.Category != null
					&& el.ParentGroup.Category.ToString()  != string.Empty )
				{
					if( GroupCheckValue.Contains( el.ParentGroup.Name  + ":::" + el.ParentGroup.Category ))
						e.Style.Text = GroupCheckValue[el.ParentGroup.Name  + ":::" + el.ParentGroup.Category].ToString() ;
					
				}
			}
		}
	}
}
